/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 931 $ $LastChangedDate: 2002-09-11 10:32:30 +0200 (Wed, 11 Sep 2002) $
 *
 * Standard library for Gont, Hashtbl module C implementation.
 */

#include <gont/runtime.h>

static gont_int prime_tab[] = {
13, 29, 59, 127, 257, 521, 1049, 2099, 4201, 8419, 16843, 33703,
67409, 134837, 269683, 539389, 1078787, 2157587, 4315183, 8630387,
17260781, 34521589, 69043189, 138086407, 276172823, 552345671,
1104691373, 0
};

gont_int Hashtbl__prime_around(gont_int x)
{
	int i = 0;

	while (prime_tab[i] && prime_tab[i] < x)
		i++;
	
	if (prime_tab[i] == 0)
		gont_invalid_argument("Hashtbl::prime_around");
	
	return prime_tab[i];
}
