/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev$ $LastChangedDate$
 *
 * Genlex - generic lexer.
 */

type mode;
type t;

union token {
    string Id;
    string Operator;
    string Blank;
    string Number;
    char Junk;
    void Eof;
}

mode make_mode();
void set_is_number(mode m, *(bool (char prev, char now)) f);
void set_is_id(mode m, *(bool (char)) f);
void set_is_op(mode m, *(bool (char)) f);
void set_is_blank(mode m, *(bool (char)) f);
void add_operator(mode, string);

t of_string(string);
t of_stream(Stdio::FILE);

char get_char(t);
char peek_char(t);
void shift_char(t);

token get_token(t, mode);

*(int, int) get_location(t);

// vim:sts=4:sw=4
