/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 945 $ $LastChangedDate: 2002-09-12 22:49:20 +0200 (Thu, 12 Sep 2002) $
 *
 * Iconv - charset conversions.
 */

type charset;
type cstring;

union approx {
	void Choke;
	void Quote;
	*(string (char)) Convert;
}

extern charset default_charset = "gont_default_charset";
extern charset default_charset_with_approx = "gont_default_charset_with_approx";

cstring get_locale_charset() = "gont_get_locale_charset";

string string_of_utf8(cstring) = "gont_string_utf8";
string string_of_locale(cstring) = "gont_string_locale";

string string_of_utf8_len(cstring, int) = "gont_string_of_utf8_";
string string_of_locale_len(cstring, int);
string string_of_charset_len(cstring, int, charset) = "gont_string_of_cstring";

*(cstring, int) string_to_utf8(string);
*(cstring, int) string_to_locale(string);
*(cstring, int) string_to_charset(string, charset);

charset lookup_charset(string);
void free_charset(charset c) = "gont_free_charset";
void set_approx(charset c, approx a);
