/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 943 $ $LastChangedDate: 2002-09-12 22:28:15 +0200 (Thu, 12 Sep 2002) $
 *
 * Standard library for Gont, String module interface.
 */

// Same as ==.
bool eq(string, string) = "gont_streq";

// One can also use <, >, >=, ...
int cmp(string, string) = "gont_strcmp";

// Same as +.
string join(string, string) = "gont_strjoin";

// This is constant time operation.
int length(string) = "gont_string_length";

string sub(string s, int pos, int len) = "gont_string_sub";
char get(string s, int idx) = "gont_string_get";
string make(int n, char c) = "gont_string_make";

string of_char_array(<char>Array::t src) = "String__of_char_array";
<char>Array::t to_char_array(string src) = "String__to_char_array";
	
string concat(string sep, <string>list lst);
void iter(*(void (char)) f, string s) = "gont_string_iter";
int index(string s, char c);
int rindex(string s, char c);
int index_from(string s, int pos, char c);
int rindex_from(string s, int pos, char c);
bool contains(string s, char c);
bool contains_from(string s, int pos, char c);
bool rcontains_from(string s, int pos, char c);

int index_str(string heystack, string needle);
int index_str_from(string heystack, int pos, string needle);
bool contains_str(string heystack, string needle);
bool contains_str_from(string heystack, int pos, string needle);

<string>list split(string sep, string s);

string capitalize(string s);
string uncapitalize(string s);
string lowercase(string s);
string uppercase(string s);

int hash(string) = "gont_string_hash";
